(*
 * SNU 4190.310 Programming Languages (Fall 2007)
 *
 * K-- Interpreter I
 *)

fun main () =
    let
      val print_code = ref false
      val src = ref ""
      val spec = [("-pp", Arg.Set print_code, "Է K-- α׷ ")]
      val usage = ": run <options> <file> \n  ɼǵ: "
      val _ = Arg.parse spec
                (fn
                   x =>
                     if Sys.file_exists x then src := x
                     else raise Arg.Bad (x ^ ":  "))
                usage
    in
      if !src = "" then Arg.usage spec usage
      else
        let
          val file_channel = open_in !src
          val lexbuf = Lexing.from_channel file_channel 
          val pgm = Parser.program Lexer.start lexbuf
        in
          if !print_code then (
              print_endline "== Է α׷ ==";
              Kminusminus_PP.pp pgm
          ) else (
             (ignore (K.run (K.emptyMemory, K.emptyEnv, pgm))) handle
                K.Error s => print_endline (": " ^ s)
          )
        end handle
          Lexer.LexicalError => print_endline (!src ^ ":  ")
    end

val _ = main ()
